local AcceptResurrect, C_DeathInfo, C_PetJournal, C_SummonInfo, CanMerchantRepair, ConfirmSummon, Dismount, ERR_ATTACK_MOUNTED, ERR_MOUNT_ALREADYMOUNTED, ERR_NOT_WHILE_MOUNTED, ERR_TAXIPLAYERALREADYMOUNTED, GetCoinTextureString, GetContainerItemLink, GetContainerNumSlots, GetCorpseRecoveryDelay, GetItemInfo, GetMoney, GetRepairAllCost, IsInInstance, IsMounted, RepairAllItems, RepopMe, SPELL_FAILED_NOT_MOUNTED, StaticPopup1, StaticPopup1Button1, UnitAffectingCombat, UseContainerItem, idTweaks, idTweaksModule, idTweaksOptions, Option, ToggleOption, Automation
do
  local _obj_0 = _G
  AcceptResurrect, C_DeathInfo, C_PetJournal, C_SummonInfo, CanMerchantRepair, ConfirmSummon, Dismount, ERR_ATTACK_MOUNTED, ERR_MOUNT_ALREADYMOUNTED, ERR_NOT_WHILE_MOUNTED, ERR_TAXIPLAYERALREADYMOUNTED, GetCoinTextureString, GetContainerItemLink, GetContainerNumSlots, GetCorpseRecoveryDelay, GetItemInfo, GetMoney, GetRepairAllCost, IsInInstance, IsMounted, RepairAllItems, RepopMe, SPELL_FAILED_NOT_MOUNTED, StaticPopup1, StaticPopup1Button1, UnitAffectingCombat, UseContainerItem, idTweaks, idTweaksModule, idTweaksOptions = _obj_0.AcceptResurrect, _obj_0.C_DeathInfo, _obj_0.C_PetJournal, _obj_0.C_SummonInfo, _obj_0.CanMerchantRepair, _obj_0.ConfirmSummon, _obj_0.Dismount, _obj_0.ERR_ATTACK_MOUNTED, _obj_0.ERR_MOUNT_ALREADYMOUNTED, _obj_0.ERR_NOT_WHILE_MOUNTED, _obj_0.ERR_TAXIPLAYERALREADYMOUNTED, _obj_0.GetCoinTextureString, _obj_0.GetContainerItemLink, _obj_0.GetContainerNumSlots, _obj_0.GetCorpseRecoveryDelay, _obj_0.GetItemInfo, _obj_0.GetMoney, _obj_0.GetRepairAllCost, _obj_0.IsInInstance, _obj_0.IsMounted, _obj_0.RepairAllItems, _obj_0.RepopMe, _obj_0.SPELL_FAILED_NOT_MOUNTED, _obj_0.StaticPopup1, _obj_0.StaticPopup1Button1, _obj_0.UnitAffectingCombat, _obj_0.UseContainerItem, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, ToggleOption = _obj_0.Option, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    mount_error_messages = {
      [ERR_ATTACK_MOUNTED] = true,
      [ERR_MOUNT_ALREADYMOUNTED] = true,
      [ERR_NOT_WHILE_MOUNTED] = true,
      [ERR_TAXIPLAYERALREADYMOUNTED] = true,
      [SPELL_FAILED_NOT_MOUNTED] = true
    },
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(Option(self, "accepting", "Accepting", "Automatically accept certain offers.", { }, {
        accept_hearthstone_bind = ToggleOption(self, "accept_hearthstone_bind", "Accept Hearthstone Bind", "Automatically accepts HearthStone binds"),
        accept_pvp_release = ToggleOption(self, "accept_pvp_release", "Accept PVP Release", "Automatically accepts PVP Release"),
        accept_resurrection = ToggleOption(self, "accept_resurrection", "Accept Resurrection", "Automatically accepts Resurrections"),
        accept_summon = ToggleOption(self, "accept_summon", "Accept Summon", "Automatically accepts Summons (disabled by default for raiders)")
      }))
      self.options:add_option(Option(self, "vendors", "Vendors", "Automate Vendor Interactions.", { }, {
        repair_gear = ToggleOption(self, "repair_gear", "Repair Gear", "Automatically repairs your gear"),
        sell_grey_items = ToggleOption(self, "sell_grey_items", "Sell Grey Items", "Automatically sells grey items")
      }))
      if idTweaks:is_retail() then
        self.options:add_option(Option(self, "minipet", "Minipet", "Minipet", { }, {
          summon = ToggleOption(self, "summon", "Summon", "Summon Random Favorite Battlepet")
        }))
      end
      if idTweaks:is_bc() then
        return self.options:add_option(Option(self, "movement", "Movement", "Movement", { }, {
          dismount = ToggleOption(self, "dismount", "Dismount", "Dismount when needed")
        }))
      end
    end,
    enable = function(self)
      self.ace_module:RegisterEvent("CONFIRM_BINDER", function(...)
        if not (self.db.accepting.accept_hearthstone_bind) then
          return 
        end
        return self:accept_hearthstone_bind()
      end)
      self.ace_module:RegisterEvent("CONFIRM_SUMMON", function(...)
        if not (self.db.accepting.accept_summon) then
          return 
        end
        if UnitAffectingCombat("player") then
          return 
        end
        return self:accept_summon()
      end)
      self.ace_module:RegisterEvent("MERCHANT_SHOW", function(...)
        if self.db.vendors.sell_grey_items == true then
          self:sell_grey_items()
        end
        if CanMerchantRepair() and self.db.vendors.repair_gear == true then
          return self:repair_gear()
        end
      end)
      self.ace_module:RegisterEvent("PLAYER_DEAD", function(...)
        if not (self.db.accepting.accept_pvp_release) then
          return 
        end
        if UnitAffectingCombat("player") then
          return 
        end
        if C_DeathInfo.GetSelfResurrectOptions() and #C_DeathInfo.GetSelfResurrectOptions() > 0 then
          return 
        end
        return self:accept_pvp_release()
      end)
      self.ace_module:RegisterEvent("RESURRECT_REQUEST", function(...)
        if not (self.db.accepting.accept_resurrection) then
          return 
        end
        if GetCorpseRecoveryDelay() ~= 0 then
          return 
        end
        return self:accept_resurrection()
      end)
      if idTweaks:is_retail() then
        self.ace_module:RegisterEvent("PLAYER_ALIVE", function(...)
          if not (idTweaks:is_retail()) then
            return 
          end
          if not (self.db.minipet.summon) then
            return 
          end
          if UnitAffectingCombat("player") then
            return 
          end
          return self:summon_battlepet()
        end)
        self.ace_module:RegisterEvent("PLAYER_CONTROL_GAINED", function(...)
          if not (idTweaks:is_retail()) then
            return 
          end
          if not (self.db.minipet.summon) then
            return 
          end
          if UnitAffectingCombat("player") then
            return 
          end
          return self:summon_battlepet()
        end)
        self.ace_module:RegisterEvent("PLAYER_ENTERING_WORLD", function(...)
          if not (idTweaks:is_retail()) then
            return 
          end
          if not (self.db.minipet.summon) then
            return 
          end
          if UnitAffectingCombat("player") then
            return 
          end
          return self:summon_battlepet()
        end)
        self.ace_module:RegisterEvent("PLAYER_MOUNT_DISPLAY_CHANGED", function(...)
          if not (idTweaks:is_retail()) then
            return 
          end
          if not (self.db.minipet.summon) then
            return 
          end
          if UnitAffectingCombat("player") then
            return 
          end
          return self:summon_battlepet()
        end)
        self.ace_module:RegisterEvent("PLAYER_UNGHOST", function(...)
          if not (idTweaks:is_retail()) then
            return 
          end
          if not (self.db.minipet.summon) then
            return 
          end
          if UnitAffectingCombat("player") then
            return 
          end
          return self:summon_battlepet()
        end)
      end
      if idTweaks:is_bc() then
        return self.ace_module:RegisterEvent("UI_ERROR_MESSAGE", function(_, _, error_message)
          if not (idTweaks:is_bc()) then
            return 
          end
          if not (self.db.movement.dismount) then
            return 
          end
          if not (IsMounted()) then
            return 
          end
          if self.mount_error_messages[error_message] then
            return self:dismount()
          end
        end)
      end
    end,
    disable = function(self)
      self.ace_module:UnregisterEvent("CONFIRM_BINDER")
      self.ace_module:UnregisterEvent("CONFIRM_SUMMON")
      self.ace_module:UnregisterEvent("MERCHANT_SHOW")
      self.ace_module:UnregisterEvent("PLAYER_DEAD")
      self.ace_module:UnregisterEvent("RESURRECT_REQUEST")
      if idTweaks:is_retail() then
        self.ace_module:UnregisterEvent("PLAYER_ALIVE")
        self.ace_module:UnregisterEvent("PLAYER_CONTROL_GAINED")
        self.ace_module:UnregisterEvent("PLAYER_ENTERING_WORLD")
        self.ace_module:UnregisterEvent("PLAYER_MOUNT_DISPLAY_CHANGED")
        self.ace_module:UnregisterEvent("PLAYER_UNGHOST")
      end
      if idTweaks:is_bc() then
        return self.ace_module:UnregisterEvent("UI_ERROR_MESSAGE")
      end
    end,
    summon_battlepet = function(self)
      return C_PetJournal.SummonRandomPet(true)
    end,
    sell_grey_items = function(self)
      for bag = 0, 4 do
        for slot = 0, GetContainerNumSlots(bag) do
          local link = GetContainerItemLink(bag, slot)
          if link and (select(3, GetItemInfo(link))) == 0 then
            UseContainerItem(bag, slot)
          end
        end
      end
    end,
    repair_gear = function(self)
      local cost = GetRepairAllCost()
      local funds = GetMoney()
      if cost == 0 then
        self.ace_module:Print("Repair: Nothing to repair")
      end
      if funds < cost then
        self.ace_module:Print("Repair: Insufficient Funds")
        return 
      end
      if cost > 0 then
        self.ace_module:Print("Repair: " .. tostring(GetCoinTextureString(cost)))
        return RepairAllItems()
      end
    end,
    accept_hearthstone_bind = function(self)
      return StaticPopup1Button1:Click()
    end,
    accept_summon = function(self)
      StaticPopup1:Hide()
      return C_SummonInfo.ConfirmSummon()
    end,
    accept_pvp_release = function(self)
      local in_instance, instance_type = IsInInstance()
      if in_instance and instance_type == "pvp" then
        return RepopMe()
      end
    end,
    accept_resurrection = function(self)
      StaticPopup1:Hide()
      return AcceptResurrect()
    end,
    dismount = function(self)
      return Dismount()
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, "Automation", "AceConsole-3.0", "AceEvent-3.0")
    end,
    __base = _base_0,
    __name = "Automation",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Automation = _class_0
end
return idTweaks:add_module(Automation(idTweaks))
